'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var React = require('react');

var noop$1 = require('lodash/noop');

var utilsHooks = require('@highlight-ui/utils-hooks');

var utilsCommons = require('@highlight-ui/utils-commons');

var classnames = require('classnames');

var toPairs = require('lodash/toPairs');

var groupBy = require('lodash/groupBy');

var typography = require('@highlight-ui/typography');

var noop = require('lodash/fp/noop');

var icon = require('@highlight-ui/icon');

var checkbox = require('@highlight-ui/checkbox');

var avatar = require('@highlight-ui/avatar');

var uniqueId = require('lodash/uniqueId');

var button = require('@highlight-ui/button');

var colorPicker = require('@highlight-ui/color-picker');

var input = require('@highlight-ui/input');

function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var noop__default$1 = /*#__PURE__*/_interopDefaultLegacy(noop$1);

var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);

var toPairs__default = /*#__PURE__*/_interopDefaultLegacy(toPairs);

var groupBy__default = /*#__PURE__*/_interopDefaultLegacy(groupBy);

var noop__default = /*#__PURE__*/_interopDefaultLegacy(noop);

var uniqueId__default = /*#__PURE__*/_interopDefaultLegacy(uniqueId);
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */


var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

function __rest(s, e) {
  var t = {};

  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}

function __spreadArray(to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
}

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};
var build = {
  exports: {}
};

(function (module, exports) {
  (function (a, b) {
    module.exports = b();
  })('undefined' == typeof self ? commonjsGlobal : self, function () {
    return function (a) {
      function b(d) {
        if (c[d]) return c[d].exports;
        var e = c[d] = {
          i: d,
          l: !1,
          exports: {}
        };
        return a[d].call(e.exports, e, e.exports, b), e.l = !0, e.exports;
      }

      var c = {};
      return b.m = a, b.c = c, b.d = function (a, c, d) {
        b.o(a, c) || Object.defineProperty(a, c, {
          configurable: !1,
          enumerable: !0,
          get: d
        });
      }, b.n = function (a) {
        var c = a && a.__esModule ? function () {
          return a['default'];
        } : function () {
          return a;
        };
        return b.d(c, 'a', c), c;
      }, b.o = function (a, b) {
        return Object.prototype.hasOwnProperty.call(a, b);
      }, b.p = './', b(b.s = 2);
    }([function (a, b, c) {
      Object.defineProperty(b, '__esModule', {
        value: !0
      }), b.useClickOutside = function () {
        function a(a) {
          b && b.current && (b.current.contains(a.target) ? h({
            hasClickedOutside: !1
          }) : h({
            hasClickedOutside: !0
          }));
        }

        const b = Object(d.useRef)();
        var c = Object(d.useState)({
          hasClickedOutside: !1
        }),
            e = f(c, 2);
        const g = e[0],
              h = e[1];
        return Object(d.useEffect)(() => (window.PointerEvent ? document.addEventListener('pointerdown', a) : (document.addEventListener('mousedown', a), document.addEventListener('touchstart', a)), () => {
          window.PointerEvent ? document.addEventListener('pointerdown', a) : (document.removeEventListener('mousedown', a), document.removeEventListener('touchstart', a));
        }), []), [b, g.hasClickedOutside];
      };
      var d = c(1);
      c.n(d);

      var f = function () {
        function a(a, b) {
          var c = [],
              d = !0,
              e = !1,
              f = void 0;

          try {
            for (var g, h = a[Symbol.iterator](); !(d = (g = h.next()).done) && (c.push(g.value), !(b && c.length === b)); d = !0);
          } catch (a) {
            e = !0, f = a;
          } finally {
            try {
              !d && h['return'] && h['return']();
            } finally {
              if (e) throw f;
            }
          }

          return c;
        }

        return function (b, c) {
          if (Array.isArray(b)) return b;
          if (Symbol.iterator in Object(b)) return a(b, c);
          throw new TypeError('Invalid attempt to destructure non-iterable instance');
        };
      }();
    }, function (a) {
      a.exports = React__default["default"];
    }, function (a, b, c) {
      a.exports = c(3);
    }, function (a, b, c) {
      Object.defineProperty(b, '__esModule', {
        value: !0
      });
      var d = c(0);
      c.d(b, 'useClickOutside', function () {
        return d.useClickOutside;
      });
    }]);
  });
})(build);

function getSelectedValues(_a) {
  var multiple = _a.multiple,
      option = _a.option,
      selectedOptions = _a.selectedOptions,
      selectedOptionsWithValuesOnly = _a.selectedOptionsWithValuesOnly;

  if (!multiple) {
    return [option];
  }

  if (selectedOptionsWithValuesOnly.includes(option.value)) {
    return selectedOptions.filter(function (selectedOption) {
      return selectedOption.value !== option.value;
    });
  }

  return __spreadArray(__spreadArray([], selectedOptions, true), [option], false);
}
/**
 * Returns options that are pre-selected and disabled.
 * @param allOptions
 * @param preSelectedOptions
 */


function getFixedOptions(allOptions, preSelectedOptions) {
  var allDisabled = allOptions.filter(function (option) {
    return option.disabled;
  });
  return allDisabled.filter(function (disabledOption) {
    return preSelectedOptions.some(function (option) {
      return option.value === disabledOption.value;
    });
  });
}
/**
 * Returns a list of option that are fixed and are enabled
 * @param options
 * @param preSelectedOptions
 */


function getAllSelectableOptions(options, preSelectedOptions) {
  var allFixed = getFixedOptions(options, preSelectedOptions);
  var allEnabled = options.filter(function (option) {
    return !option.disabled;
  });
  return __spreadArray(__spreadArray([], allFixed, true), allEnabled, true);
}

var styles$e = {
  "label": "List-module__3eBtAqWo__v8-0-10",
  "labelWrapper": "List-module__2N1Czcx___v8-0-10",
  "optionIcon": "List-module__20whLBmg__v8-0-10",
  "option": "List-module__WP03aTyu__v8-0-10",
  "optionCheckbox": "List-module__1xCWbakz__v8-0-10",
  "multiLineOption": "List-module__2XiLBsmo__v8-0-10",
  "selectedText": "List-module__3JZZHD7o__v8-0-10",
  "disabled": "List-module__2wCQU5ux__v8-0-10",
  "multiLineIcon": "List-module__1vZ64tez__v8-0-10",
  "multiLineCheckbox": "List-module__37RkH873__v8-0-10",
  "subLabel": "List-module__1Nm6OsGP__v8-0-10",
  "list": "List-module__2ObHKkci__v8-0-10",
  "multiLineList": "List-module__1qnvYofW__v8-0-10",
  "fullWidth": "List-module__3axRkzKW__v8-0-10",
  "noResults": "List-module__n88tLk_9__v8-0-10"
};
var styles$d = {
  "labelWrapper": "Option-module__1--7xK7L__v8-0-10",
  "optionIcon": "Option-module__peJcMBH7__v8-0-10",
  "option": "Option-module__2ym46zUu__v8-0-10",
  "optionCheckbox": "Option-module__zaLdwsO3__v8-0-10",
  "multiLineOption": "Option-module__1qplZ2cB__v8-0-10",
  "selectedText": "Option-module__3WqFb6sf__v8-0-10",
  "disabled": "Option-module__2dJafLVp__v8-0-10",
  "multiLineIcon": "Option-module__1CYZ9njy__v8-0-10",
  "multiLineCheckbox": "Option-module__2pPtBn6k__v8-0-10"
}; // eslint-disable-next-line import/prefer-default-export

var searchSubstring = function (string, substring) {
  return string.toLowerCase().indexOf(substring.toLowerCase());
};

var styles$c = {
  "selected": "TextWithHighlight-module__3kv_bPCG__v8-0-10"
};

var TextWithHighlight = function (_a) {
  var _b;

  var highlightedText = _a.highlightedText,
      text = _a.text,
      _c = _a.selected,
      selected = _c === void 0 ? false : _c,
      _d = _a.disabled,
      disabled = _d === void 0 ? false : _d;
  var startIndex = searchSubstring(text, highlightedText);
  if (startIndex === -1) return React__default["default"].createElement(React__default["default"].Fragment, null, text);
  var endIndex = startIndex + highlightedText.length;
  return React__default["default"].createElement(typography.Typography, {
    component: "span",
    variant: "body-1",
    color: disabled ? 'text-disabled' : 'text-default',
    className: classnames__default["default"]((_b = {}, _b[styles$c.selected] = selected, _b))
  }, text.substring(0, startIndex), React__default["default"].createElement("b", null, text.substring(startIndex, endIndex)), text.substring(endIndex));
};

function SingleLineOptionLabel(_a) {
  var option = _a.option,
      highlightedText = _a.highlightedText,
      selected = _a.selected,
      disabled = _a.disabled;
  return React__default["default"].createElement(TextWithHighlight, {
    highlightedText: highlightedText,
    text: option.label,
    selected: selected,
    disabled: disabled
  });
}

var styles$b = {
  "label": "MultiLineOptionLabel-module__3fgNK2Xm__v8-0-10",
  "subLabel": "MultiLineOptionLabel-module__1iJeXNPV__v8-0-10",
  "disabled": "MultiLineOptionLabel-module__2ftMukhR__v8-0-10"
};

function MultiLineOptionLabel(_a) {
  var _b;

  var option = _a.option,
      highlightedText = _a.highlightedText,
      selected = _a.selected,
      disabled = _a.disabled;
  return React__default["default"].createElement(React__default["default"].Fragment, null, React__default["default"].createElement("span", {
    className: styles$b.label
  }, React__default["default"].createElement(TextWithHighlight, {
    highlightedText: highlightedText,
    text: option.label,
    selected: selected,
    disabled: disabled
  })), React__default["default"].createElement(typography.Typography, {
    className: classnames__default["default"](styles$b.subLabel, (_b = {}, _b[styles$b.disabled] = option.disabled, _b)),
    component: "span",
    variant: "body-1",
    title: option.subLabel
  }, option.subLabel));
}

var styles$a = {
  "colorIcon": "ColoredOptionLabel-module__12fSpv1G__v8-0-10"
};

function ColoredOptionLabel(_a) {
  var option = _a.option,
      highlightedText = _a.highlightedText,
      selected = _a.selected,
      disabled = _a.disabled;
  return React__default["default"].createElement(React__default["default"].Fragment, null, React__default["default"].createElement("span", {
    className: styles$a.colorIcon,
    style: {
      color: !option.disabled ? option.color : undefined
    }
  }, React__default["default"].createElement(icon.Icon, {
    name: "circle",
    type: "solid",
    size: 12
  })), React__default["default"].createElement(TextWithHighlight, {
    highlightedText: highlightedText,
    text: option.label,
    selected: selected,
    disabled: disabled
  }));
}

var styles$9 = {
  "label": "AvatarOptionLabel-module__3XTEg39V__v8-0-10",
  "subLabel": "AvatarOptionLabel-module__SE9NqSW9__v8-0-10",
  "wrapper": "AvatarOptionLabel-module__3MbElNjg__v8-0-10",
  "avatar": "AvatarOptionLabel-module__duV8vrCr__v8-0-10",
  "disabledAvatar": "AvatarOptionLabel-module__3H7pKms-__v8-0-10",
  "labelsWrapper": "AvatarOptionLabel-module__1iX_lfeO__v8-0-10",
  "disabled": "AvatarOptionLabel-module__BohvL_H4__v8-0-10"
};

function AvatarOptionLabel(_a) {
  var _b, _c;

  var option = _a.option,
      highlightedText = _a.highlightedText,
      selected = _a.selected,
      disabled = _a.disabled;
  return React__default["default"].createElement("div", {
    className: styles$9.wrapper
  }, React__default["default"].createElement(avatar.Avatar, {
    src: option.avatar,
    name: option.label,
    containerClassname: classnames__default["default"](styles$9.avatar, (_b = {}, _b[styles$9.disabledAvatar] = option.disabled, _b))
  }), React__default["default"].createElement("div", {
    className: styles$9.labelsWrapper
  }, React__default["default"].createElement("span", {
    className: styles$9.label
  }, React__default["default"].createElement(TextWithHighlight, {
    highlightedText: highlightedText,
    text: option.label,
    selected: selected,
    disabled: disabled
  })), React__default["default"].createElement(typography.Typography, {
    className: classnames__default["default"](styles$9.subLabel, (_c = {}, _c[styles$9.disabled] = option.disabled, _c)),
    component: "span",
    variant: "body-1",
    title: option.subLabel
  }, option.subLabel)));
}

var optionLabelComponents = {
  'single-line': SingleLineOptionLabel,
  'multi-line': MultiLineOptionLabel,
  colored: ColoredOptionLabel,
  avatar: AvatarOptionLabel
};

function Option(_a) {
  var _b, _c, _d;

  var disabled = _a.disabled,
      highlightedText = _a.highlightedText,
      onSelect = _a.onSelect,
      option = _a.option,
      optionStyle = _a.optionStyle,
      optionType = _a.optionType,
      selected = _a.selected,
      className = _a.className;
  return React__default["default"].createElement("li", __assign({
    "aria-selected": selected,
    className: classnames__default["default"](styles$d.option, className, (_b = {}, _b[styles$d.selectedText] = selected && optionStyle === 'checkmark', _b[styles$d.multiLineOption] = optionType === 'multi-line', _b[styles$d.disabled] = disabled, _b)),
    onClick: !disabled ? onSelect : noop__default["default"],
    onKeyDown: !disabled ? onSelect : noop__default["default"],
    role: "option",
    title: option.label,
    tabIndex: -1
  }, utilsCommons.parseMetadata(option.metadata)), optionStyle === 'checkbox' ? React__default["default"].createElement(React__default["default"].Fragment, null, React__default["default"].createElement(checkbox.Checkbox, {
    className: classnames__default["default"](styles$d.optionCheckbox, (_c = {}, _c[styles$d.multiLineCheckbox] = optionType === 'multi-line', _c)),
    checked: selected,
    readOnly: true,
    disabled: disabled
  }), React__default["default"].createElement("div", {
    className: styles$d.labelWrapper
  }, React__default["default"].createElement(optionLabelComponents[optionType], {
    option: option,
    highlightedText: highlightedText,
    selected: false,
    disabled: disabled
  }))) : React__default["default"].createElement(React__default["default"].Fragment, null, React__default["default"].createElement(icon.Icon, {
    className: classnames__default["default"](styles$d.optionIcon, (_d = {}, _d[styles$d.multiLineIcon] = optionType === 'multi-line', _d)),
    name: "check",
    size: 14,
    type: "solid"
  }), React__default["default"].createElement("div", {
    className: styles$d.labelWrapper
  }, React__default["default"].createElement(optionLabelComponents[optionType], {
    option: option,
    highlightedText: highlightedText,
    selected: selected,
    disabled: disabled
  }))));
}

var styles$8 = {
  "optionGroup": "OptionGroup-module__3LhwaP6p__v8-0-10",
  "optionGroupName": "OptionGroup-module__2ZREs1EZ__v8-0-10"
};

function OptionGroup(_a) {
  var name = _a.name,
      children = _a.children;
  return React__default["default"].createElement("li", {
    className: styles$8.optionGroup
  }, React__default["default"].createElement(typography.Typography, {
    className: styles$8.optionGroupName,
    variant: "subtitle-2",
    component: "div"
  }, name), React__default["default"].createElement("ul", null, children));
}

var styles$7 = {
  "wrapper": "SearchInput-module__2ZvRInZD__v8-0-10",
  "icon": "SearchInput-module__13jt8OmH__v8-0-10"
};

var SearchInputWithRef = function (_a, ref) {
  var _b = _a.placeholder,
      placeholder = _b === void 0 ? '' : _b,
      value = _a.value,
      onTextChange = _a.onTextChange;
  var id = React.useState(function () {
    return uniqueId__default["default"]('component-');
  })[0];

  var handleChange = function (event) {
    return onTextChange(event.currentTarget.value);
  };

  return React__default["default"].createElement("div", {
    className: styles$7.wrapper,
    role: "search"
  }, React__default["default"].createElement("label", {
    htmlFor: id
  }, React__default["default"].createElement(icon.Icon, {
    className: styles$7.icon,
    color: "icon-subdued",
    name: "search",
    size: 12
  }), React__default["default"].createElement("input", {
    defaultValue: value,
    id: id,
    onChange: handleChange,
    placeholder: placeholder,
    ref: ref,
    type: "search"
  })));
};

SearchInputWithRef.displayName = 'SearchInput';
var SearchInput = React__default["default"].forwardRef(SearchInputWithRef);
var styles$6 = {
  "creatableFooterContainer": "AddOptionsFooter-module__3lpPIsIg__v8-0-10",
  "inputWrapper": "AddOptionsFooter-module__2h7N5O7p__v8-0-10",
  "colorPicker": "AddOptionsFooter-module__2tQh2gdt__v8-0-10"
};

var deriveFooterButtonState = function (inputValue, loading) {
  if (inputValue.length === 0) return 'disabled';
  if (loading) return 'loading';
  return 'enabled';
};

function AddOptionsFooter(_a) {
  var createButtonProps = _a.createButtonProps,
      inputProps = _a.inputProps,
      onCreate = _a.onCreate,
      colorPickerOptions = _a.colorPickerOptions;

  var _b = React.useState(''),
      inputValue = _b[0],
      setInputValue = _b[1];

  var _c = React.useState(colorPickerOptions === null || colorPickerOptions === void 0 ? void 0 : colorPickerOptions.initialColor),
      color = _c[0],
      setColor = _c[1];

  var onAddHandler = function () {
    onCreate(__assign({
      value: inputValue || ''
    }, color ? {
      color: color
    } : {}));
  };

  var onInputChange = function (event) {
    setInputValue(event.target.value);
  };

  return React__default["default"].createElement("footer", {
    className: styles$6.creatableFooterContainer
  }, React__default["default"].createElement(input.TextInput, {
    placeholder: inputProps === null || inputProps === void 0 ? void 0 : inputProps.placeholder,
    className: styles$6.inputWrapper,
    onKeyPress: function (e) {
      if (e.key.toLowerCase() === 'enter' && inputValue) onAddHandler();
    },
    metadata: inputProps === null || inputProps === void 0 ? void 0 : inputProps.metadata,
    onChange: onInputChange
  }), colorPickerOptions && React__default["default"].createElement("div", {
    className: styles$6.colorPicker
  }, React__default["default"].createElement(colorPicker.ColorPicker, {
    closeOnSelect: true,
    initialColor: color,
    metadata: colorPickerOptions.metadata,
    onChange: setColor,
    palette: colorPickerOptions.palette,
    title: colorPickerOptions.title
  })), React__default["default"].createElement(button.Button, {
    variant: "primary",
    onClick: onAddHandler,
    buttonState: deriveFooterButtonState(inputValue, createButtonProps.loading)
  }, createButtonProps.label));
}

var styles$5 = {
  "loadingContainer": "LoadingState-module__1kM3jMVC__v8-0-10"
};

function LoadingState() {
  return React__default["default"].createElement("div", {
    className: styles$5.loadingContainer,
    "aria-label": "loading"
  }, React__default["default"].createElement(icon.Icon, {
    name: "spinner-third",
    size: 16,
    spin: true,
    color: "icon-highlight",
    type: "solid"
  }));
}

var styles$4 = {
  "submitFooterContainer": "SubmitFooter-module__1YkFWgco__v8-0-10",
  "cancelButton": "SubmitFooter-module__IHUTMbpw__v8-0-10"
};

var SubmitFooter = function (_a) {
  var onSubmit = _a.onSubmit,
      onCancel = _a.onCancel,
      _b = _a.submitLabel,
      submitLabel = _b === void 0 ? 'Apply' : _b,
      _c = _a.cancelSubmitLabel,
      cancelSubmitLabel = _c === void 0 ? 'Cancel' : _c;
  return React__default["default"].createElement("footer", {
    className: styles$4.submitFooterContainer
  }, React__default["default"].createElement(typography.Typography, {
    component: "button",
    variant: "button-1",
    className: styles$4.cancelButton,
    onClick: onCancel,
    type: "button"
  }, cancelSubmitLabel), React__default["default"].createElement(button.Button, {
    variant: "primary",
    onClick: onSubmit
  }, submitLabel));
};

var styles$3 = {
  "selectAllOption": "SelectAllOption-module__Nph5J00o__v8-0-10"
};

var SelectAllOption = function (_a) {
  var isSelected = _a.isSelected,
      onSelect = _a.onSelect,
      label = _a.label;
  var selectAllOption = React.useMemo(function () {
    return {
      value: Date.now(),
      label: label
    };
  }, [label]);
  return React__default["default"].createElement(Option, {
    highlightedText: "",
    onSelect: function () {
      return onSelect(!isSelected);
    },
    option: selectAllOption,
    optionStyle: "checkbox",
    optionType: "single-line",
    selected: isSelected,
    className: styles$3.selectAllOption
  });
};

var MIN_OPTIONS_TO_DISPLAY_SELECT_ALL = 7.5;
var MIN_GROUPS_TO_DISPLAY_HEADER = 2;

function List(_a, ref) {
  var _b;

  var className = _a.className,
      selectAllLabel = _a.selectAllLabel,
      highlightedText = _a.highlightedText,
      variant = _a.variant,
      multiple = _a.multiple,
      onSelect = _a.onSelect,
      onSelectAll = _a.onSelectAll,
      onSearchChange = _a.onSearchChange,
      options = _a.options,
      optionType = _a.optionType,
      emptyStateLabel = _a.emptyStateLabel,
      renderEmptyState = _a.renderEmptyState,
      searchable = _a.searchable,
      searchInitialValue = _a.searchInitialValue,
      searchAutofocus = _a.searchAutofocus,
      searchPlaceholder = _a.searchPlaceholder,
      searchNoResultsLabel = _a.searchNoResultsLabel,
      minOptionsToDisplaySearch = _a.minOptionsToDisplaySearch,
      selectedOptionsWithValuesOnly = _a.selectedOptionsWithValuesOnly,
      creatableOptions = _a.creatableOptions,
      style = _a.style,
      isLoading = _a.isLoading,
      submitOptions = _a.submitOptions,
      onSubmit = _a.onSubmit,
      onCancel = _a.onCancel,
      metadata = _a.metadata,
      restProps = __rest(_a, ["className", "selectAllLabel", "highlightedText", "variant", "multiple", "onSelect", "onSelectAll", "onSearchChange", "options", "optionType", "emptyStateLabel", "renderEmptyState", "searchable", "searchInitialValue", "searchAutofocus", "searchPlaceholder", "searchNoResultsLabel", "minOptionsToDisplaySearch", "selectedOptionsWithValuesOnly", "creatableOptions", "style", "isLoading", "submitOptions", "onSubmit", "onCancel", "metadata"]);

  var _c = React.useState(searchInitialValue),
      searchInputValue = _c[0],
      setSearchInputValue = _c[1];

  var searchInputRef = React.useRef(null);
  React.useEffect(function () {
    if (!searchAutofocus || !searchInputRef.current) return;
    setTimeout(function () {
      if (searchInputRef.current) searchInputRef.current.focus();
    }); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  var shouldShowSelectAll = multiple && options.length > MIN_OPTIONS_TO_DISPLAY_SELECT_ALL && searchInputValue.length === 0;
  var selectAllIsSelected = options.length === selectedOptionsWithValuesOnly.length;
  var filteredOptions = options.filter(function (option) {
    return searchSubstring(option.label, searchInputValue) !== -1;
  });
  var shouldShowNoResultsLabel = searchInputValue !== '' && filteredOptions.length === 0;
  var shouldShowSearchInput = searchable && options.length >= minOptionsToDisplaySearch;
  var groupedOptions = groupBy__default["default"](filteredOptions, function (option) {
    return option.group;
  });
  var shouldShowGroups = Object.keys(groupedOptions).length >= MIN_GROUPS_TO_DISPLAY_HEADER;

  var renderOptions = function (optionsList) {
    var optionsRendered = optionsList.map(function (option) {
      return React__default["default"].createElement(Option, {
        disabled: option.disabled,
        highlightedText: searchable ? searchInputValue : highlightedText,
        key: option.value,
        onSelect: function () {
          return onSelect(option);
        },
        option: option,
        optionStyle: multiple ? 'checkbox' : 'checkmark',
        optionType: optionType,
        selected: selectedOptionsWithValuesOnly.includes(option.value)
      });
    });
    return React__default["default"].createElement(React__default["default"].Fragment, null, shouldShowSelectAll && !shouldShowGroups && React__default["default"].createElement(SelectAllOption, {
      onSelect: onSelectAll,
      isSelected: selectAllIsSelected,
      label: selectAllLabel
    }), optionsRendered);
  };

  var renderOptionGroups = function () {
    var groupsRendered = toPairs__default["default"](groupedOptions).map(function (_a) {
      var groupName = _a[0],
          groupOptions = _a[1];
      return React__default["default"].createElement(OptionGroup, {
        key: groupName,
        name: groupName
      }, renderOptions(groupOptions));
    });
    return React__default["default"].createElement(React__default["default"].Fragment, null, shouldShowSelectAll && React__default["default"].createElement(SelectAllOption, {
      onSelect: onSelectAll,
      isSelected: selectAllIsSelected,
      label: selectAllLabel
    }), groupsRendered);
  };

  var handleSearchInputChange = function (search) {
    setSearchInputValue(search);
    onSearchChange(search);
  };

  return React__default["default"].createElement("div", __assign({
    ref: ref,
    className: classnames__default["default"](styles$e.list, className, (_b = {}, _b[styles$e.multiLineList] = optionType === 'multi-line', _b[styles$e.fullWidth] = variant === 'full-width', _b)),
    style: style
  }, utilsCommons.parseMetadata(utilsCommons.suffixMetadata(metadata, 'list')), restProps), isLoading ? React__default["default"].createElement(LoadingState, null) : React__default["default"].createElement(React__default["default"].Fragment, null, shouldShowSearchInput && React__default["default"].createElement(SearchInput, {
    ref: searchInputRef,
    placeholder: searchPlaceholder,
    value: searchInputValue,
    onTextChange: handleSearchInputChange
  }), shouldShowNoResultsLabel && React__default["default"].createElement(typography.Typography, {
    component: "div",
    variant: "body-1",
    className: styles$e.noResults
  }, searchNoResultsLabel + " \"" + searchInputValue + "\""), !shouldShowNoResultsLabel && (options.length === 0 ? renderEmptyState({
    label: emptyStateLabel
  }) : React__default["default"].createElement("ul", {
    role: "listbox"
  }, shouldShowGroups ? renderOptionGroups() : renderOptions(filteredOptions))), creatableOptions && React__default["default"].createElement(AddOptionsFooter, {
    onCreate: creatableOptions.onCreate,
    createButtonProps: creatableOptions.createButtonProps,
    inputProps: creatableOptions.inputProps,
    colorPickerOptions: creatableOptions.colorPickerOptions
  }), !creatableOptions && submitOptions && React__default["default"].createElement(SubmitFooter, {
    onSubmit: onSubmit,
    onCancel: onCancel,
    submitLabel: submitOptions.submitLabel,
    cancelSubmitLabel: submitOptions.cancelLabel
  })));
}

var ListWithRef = React.forwardRef(List);
var styles$2 = {
  "defaultEmptyState": "DefaultEmptyState-module__2GMCdSkP__v8-0-10"
};

function DefaultEmptyState(_a) {
  var label = _a.label;
  return React__default["default"].createElement(typography.Typography, {
    className: styles$2.defaultEmptyState,
    variant: "body-1",
    component: "div"
  }, label);
}

var styles$1 = {
  "selectTrigger": "DefaultTrigger-module__1Lcj4UJj__v8-0-10",
  "selected": "DefaultTrigger-module__2pDPCVHO__v8-0-10",
  "fullWidth": "DefaultTrigger-module__16yCD6zm__v8-0-10",
  "innerText": "DefaultTrigger-module__1VgmRcUO__v8-0-10",
  "outline-warning": "DefaultTrigger-module__3iRFUG-L__v8-0-10",
  "outline-error": "DefaultTrigger-module__1zBxYiiH__v8-0-10",
  "disabled": "DefaultTrigger-module__e9ZX9U5___v8-0-10",
  "icon": "DefaultTrigger-module__3O-cbhK6__v8-0-10"
};
var styles = {
  "selectClearButton": "SelectClearButton-module__3m8ZA7Fl__v8-0-10"
};

var SelectClearButton = function (_a) {
  var onClick = _a.onClick,
      disabled = _a.disabled,
      _b = _a.ariaLabelClearButton,
      ariaLabelClearButton = _b === void 0 ? 'Clear Select Input' : _b;
  return React__default["default"].createElement("div", {
    role: "button",
    className: styles.selectClearButton,
    onClick: disabled ? noop__default$1["default"] : onClick,
    onKeyPress: disabled ? noop__default$1["default"] : onClick,
    tabIndex: -1,
    "aria-label": ariaLabelClearButton
  }, React__default["default"].createElement(icon.Icon, {
    name: "times-circle",
    type: "solid",
    color: "icon-subdued"
  }));
};

function DefaultTrigger(_a) {
  var _b;

  var disabled = _a.disabled,
      variant = _a.variant,
      label = _a.label,
      multiple = _a.multiple,
      onClick = _a.onClick,
      selectedOptions = _a.selectedOptions,
      visible = _a.visible,
      _c = _a.outline,
      outline = _c === void 0 ? 'default' : _c,
      _d = _a.autoFocus,
      autoFocus = _d === void 0 ? false : _d,
      triggerId = _a.triggerId,
      onClear = _a.onClear,
      ref = _a.ref;
  var hasSelectedOption = selectedOptions.length > 0;

  var renderSingleSelectionLabel = function () {
    var firstItem = selectedOptions[0];
    return hasSelectedOption ? firstItem.label : label;
  };

  var renderMultiSelectionLabel = function () {
    return hasSelectedOption ? label + " \u00B7 " + selectedOptions.length : label;
  };

  var isFullWidth = variant === 'full-width';
  return React__default["default"].createElement("button", __assign({
    ref: ref,
    className: classnames__default["default"](styles$1.selectTrigger, styles$1["outline-" + outline], (_b = {}, _b[styles$1.fullWidth] = isFullWidth, _b[styles$1.selected] = hasSelectedOption, _b[styles$1.disabled] = disabled, _b)),
    type: "button",
    disabled: disabled,
    onClick: onClick,
    // eslint-disable-next-line jsx-a11y/no-autofocus
    autoFocus: autoFocus
  }, triggerId ? {
    id: triggerId
  } : {}), React__default["default"].createElement("span", {
    className: styles$1.innerText
  }, multiple ? renderMultiSelectionLabel() : renderSingleSelectionLabel()), onClear && selectedOptions.length > 0 ? React__default["default"].createElement(SelectClearButton, {
    onClick: onClear,
    disabled: disabled
  }) : null, React__default["default"].createElement(icon.Icon, {
    className: styles$1.icon,
    name: visible ? 'angle-up' : 'angle-down',
    type: "solid",
    color: "icon-default"
  }));
}

var useListVisibilityChangeHandler = function (onListVisibilityChange, visible) {
  var initialRender = React.useRef(true);
  React.useEffect(function () {
    if (initialRender.current) {
      initialRender.current = false;
    } else {
      onListVisibilityChange(visible);
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [visible]);
};

function SelectWithRef(_a, ref) {
  var className = _a.className,
      listClassName = _a.listClassName,
      _b = _a.closeOnSelect,
      closeOnSelect = _b === void 0 ? false : _b,
      _c = _a.disabled,
      disabled = _c === void 0 ? false : _c,
      _d = _a.variant,
      variant = _d === void 0 ? 'inline' : _d,
      _e = _a.selectAllLabel,
      selectAllLabel = _e === void 0 ? 'Select all' : _e,
      metadata = _a.metadata,
      _f = _a.multiple,
      multiple = _f === void 0 ? false : _f,
      _g = _a.onSearchChange,
      onSearchChange = _g === void 0 ? noop__default$1["default"] : _g,
      _h = _a.onSelect,
      onSelect = _h === void 0 ? noop__default$1["default"] : _h,
      _j = _a.onListVisibilityChange,
      onListVisibilityChange = _j === void 0 ? noop__default$1["default"] : _j,
      options = _a.options,
      _k = _a.emptyStateLabel,
      emptyStateLabel = _k === void 0 ? 'Nothing to display' : _k,
      _l = _a.renderEmptyState,
      renderEmptyState = _l === void 0 ? DefaultEmptyState : _l,
      _m = _a.renderTrigger,
      renderTrigger = _m === void 0 ? DefaultTrigger : _m,
      _o = _a.optionType,
      optionType = _o === void 0 ? 'single-line' : _o,
      _p = _a.searchable,
      searchable = _p === void 0 ? true : _p,
      _q = _a.searchAutofocus,
      searchAutofocus = _q === void 0 ? true : _q,
      _r = _a.searchInitialValue,
      searchInitialValue = _r === void 0 ? '' : _r,
      _s = _a.searchNoResultsLabel,
      searchNoResultsLabel = _s === void 0 ? 'No results for' : _s,
      _t = _a.searchPlaceholder,
      searchPlaceholder = _t === void 0 ? 'Search' : _t,
      _u = _a.selectedOptions,
      selectedOptions = _u === void 0 ? [] : _u,
      _v = _a.minOptionsToDisplaySearch,
      minOptionsToDisplaySearch = _v === void 0 ? 8 : _v,
      _w = _a.triggerLabel,
      triggerLabel = _w === void 0 ? '' : _w,
      _x = _a.outline,
      outline = _x === void 0 ? 'default' : _x,
      _y = _a.autoFocus,
      autoFocus = _y === void 0 ? false : _y,
      triggerId = _a.triggerId,
      creatableOptions = _a.creatableOptions,
      _z = _a.isClearable,
      isClearable = _z === void 0 ? false : _z,
      _0 = _a.highlightedText,
      highlightedText = _0 === void 0 ? '' : _0,
      _1 = _a.isLoading,
      isLoading = _1 === void 0 ? false : _1,
      submitOptions = _a.submitOptions;

  var _2 = build.exports.useClickOutside(),
      clickOutsideRef = _2[0],
      hasClickedOutside = _2[1];

  var _3 = React.useState(false),
      visible = _3[0],
      setVisibility = _3[1];

  var _4 = utilsHooks.useAutoPositioner(),
      setReferenceElement = _4.setReferenceElement,
      setPopperElement = _4.setPopperElement,
      popperStyles = _4.styles.popper,
      attributes = _4.attributes;

  useListVisibilityChangeHandler(onListVisibilityChange, visible);
  React.useEffect(function () {
    if (hasClickedOutside && visible) {
      setVisibility(false);

      if (submitOptions) {
        submitOptions.onCancel();
      }
    }
  }, [hasClickedOutside, visible, submitOptions]);
  var selectedOptionsWithValuesOnly = React.useMemo(function () {
    return selectedOptions.map(function (selectedOption) {
      return selectedOption.value;
    });
  }, [selectedOptions]);

  var beforeSelect = function (callback) {
    return function () {
      var args = [];

      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }

      if (closeOnSelect) setVisibility(false);
      callback.apply(void 0, args);
    };
  };

  var handleClear = function (evt) {
    evt.stopPropagation();
    var fixedOptions = getFixedOptions(options, selectedOptions);
    onSelect(fixedOptions);

    if (submitOptions) {
      submitOptions.onSubmit(fixedOptions);
    }

    setVisibility(false);
  };

  var handleSelectAll = function (selected) {
    var opts = selected ? getAllSelectableOptions(options, selectedOptions) : getFixedOptions(options, selectedOptions);
    onSelect(opts);
  };

  var handleSelect = function (option) {
    onSelect(getSelectedValues({
      option: option,
      selectedOptions: selectedOptions,
      selectedOptionsWithValuesOnly: selectedOptionsWithValuesOnly,
      multiple: multiple
    }));
  };

  var handleTriggerClick = function () {
    setVisibility(function (currentVisibility) {
      return !currentVisibility;
    });

    if (visible && submitOptions) {
      submitOptions.onCancel();
    }
  };

  var finalRef = utilsHooks.useForkRef([clickOutsideRef, ref]);

  var _5 = React.useState(),
      triggerWidth = _5[0],
      setTriggerWidth = _5[1];

  var triggerRef = utilsHooks.useForkRef([setReferenceElement, function (elem) {
    if (elem) setTriggerWidth(getComputedStyle(elem).width);
  }]);

  var handleSubmit = function () {
    if (submitOptions) submitOptions.onSubmit(selectedOptions);
    setVisibility(false);
  };

  var handleCancelSubmit = function () {
    setVisibility(false);
    if (submitOptions) submitOptions.onCancel();
  };

  return React__default["default"].createElement("div", __assign({
    className: className,
    ref: finalRef
  }, utilsCommons.parseMetadata(metadata)), React__default["default"].createElement("div", null, renderTrigger({
    selectRef: clickOutsideRef,
    ref: triggerRef,
    disabled: disabled,
    variant: variant,
    label: triggerLabel,
    multiple: multiple,
    onClick: handleTriggerClick,
    selectedOptions: selectedOptions,
    visible: visible,
    outline: outline,
    autoFocus: autoFocus,
    triggerId: triggerId,
    setListVisibility: setVisibility,
    onClear: isClearable ? handleClear : undefined
  })), visible && React__default["default"].createElement(ListWithRef, __assign({
    className: listClassName,
    metadata: metadata,
    selectAllLabel: selectAllLabel,
    isLoading: isLoading,
    highlightedText: highlightedText,
    variant: variant,
    multiple: multiple,
    onSelect: beforeSelect(handleSelect),
    onSelectAll: beforeSelect(handleSelectAll),
    onSearchChange: onSearchChange,
    options: options,
    optionType: optionType,
    emptyStateLabel: emptyStateLabel,
    renderEmptyState: renderEmptyState,
    selectedOptionsWithValuesOnly: selectedOptionsWithValuesOnly,
    searchable: searchable,
    searchNoResultsLabel: searchNoResultsLabel,
    searchPlaceholder: searchPlaceholder,
    searchInitialValue: searchInitialValue,
    searchAutofocus: searchAutofocus,
    minOptionsToDisplaySearch: minOptionsToDisplaySearch,
    onSubmit: handleSubmit,
    onCancel: handleCancelSubmit,
    submitOptions: submitOptions,
    creatableOptions: creatableOptions ? __assign(__assign({}, creatableOptions), {
      onCreate: function (createdItem) {
        if (closeOnSelect && !multiple) setVisibility(false);
        creatableOptions.onCreate(createdItem);
      }
    }) : creatableOptions,
    ref: setPopperElement,
    style: __assign(__assign(__assign({}, popperStyles), variant === 'full-width' ? {
      width: triggerWidth
    } : {}), isLoading ? {
      minWidth: triggerWidth
    } : {})
  }, attributes.popper)));
}

SelectWithRef.displayName = 'Select';
/**
 * According to this article: https://fettblog.eu/typescript-react-generic-forward-refs/
 */

var Select = React__default["default"].forwardRef(SelectWithRef);
exports.DefaultEmptyState = DefaultEmptyState;
exports.Select = Select;
//# sourceMappingURL=index.js.map
